VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} xmloutput 
   Caption         =   "Choose an xml output format"
   ClientHeight    =   1320
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   3765
   OleObjectBlob   =   "xmloutput.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "xmloutput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

















Option Explicit


Private Sub OKButton_Click()
    Call Selected_Output
End Sub

Private Sub OutputList_DblClick(ByVal Cancel As MsForms.ReturnBoolean)
    Call Selected_Output
End Sub

Private Sub OutputList_KeyPress(ByVal KeyAscii As MsForms.ReturnInteger)
    If KeyAscii = vbKeyReturn Then
        Call Selected_Output
    End If
End Sub

Private Sub CancelButton_Click()
    XML_Output = 255
    Unload Me
End Sub

Private Sub cmdExit_Click()
    XML_Output = 255
    Unload Me
End Sub

Private Sub xmloutput_KeyPress(ByVal KeyAscii As MsForms.ReturnInteger)
    If KeyAscii = vbKeyEscape Then
        XML_Output = 255
        Unload Me
    End If
End Sub

Public Sub Selected_Output()
    XML_Output = xmloutput.OutputList.ListIndex
    WriteReg RegFolder & "XML Output", XML_Output & "", REG_DWORD
    Unload Me
End Sub

Public Sub SelectedOutput()
    Dim OutputSelection As Byte
    Dim OutputString As String
    Dim RegPath As String
    Dim i As Integer
    Dim FileString As String
    Dim UpdateXML As Boolean
    Dim StringStart As Integer
    Dim StringEnd As Integer
    Dim FullText As String
    Dim FileNameFromPath As String
    Dim FolderFromPath As String
    Dim FilePath As String
    Dim TrimmedString As String
    Dim XMLStart As Long
    Dim XMLEnd As Long
    Dim TrimmedChar As String
    Dim PatchString As String
    Dim FFTorgASM As String
    Dim PatchAtTheEnd As Boolean
    Dim objStream, strData
    OutputSelection = xmloutput.OutputList.ListIndex
    WriteReg RegFolder & "XML Output", OutputSelection & "", REG_DWORD

    With Worksheets(".xml")
        Select Case OutputSelection
            Case 0
                If ReadReg(RegFolder & "Don't Trim XML", ActiveWorkbook.path) = "1" Then
                    OptimizeMe
                    .Range(.Cells(1, 13), .Cells(GetXMLLastRow, 13)).Copy
                Else
                    OptimizeMe
                    .Range(.Cells(3, 13), .Cells(GetXMLLastRow - 1, 13)).Copy
                End If
                GoTo SubEnd
            Case 1
                UpdateXML = True
            Case 2
                UpdateXML = False
        End Select
    End With
    Unload Me

    RegPath = RegFolder & "Last XML"
    FilePath = ReadReg(RegPath, ActiveWorkbook.path)
    If Len(FilePath) < 5 Then FilePath = ActiveWorkbook.path & "\a"
    FolderFromPath = Left(FilePath, InStrRev(FilePath, "\"))
    If Len(Dir(FolderFromPath)) Then ChDir FolderFromPath
    
    If UpdateXML Then
        FilePath = Application.GetOpenFilename(FileFilter:="FFTOrgASM File (*.xml), *.xml", Title:="Select an XML file", MultiSelect:=False)
    Else
        FilePath = Application.GetSaveAsFilename(FileFilter:="FFTOrgASM File (*.xml), *.xml", Title:="Choose a Filename")
    End If
    If FilePath = "False" Then
        GoTo SubEnd
    End If
    WriteReg RegPath, FilePath
    OptimizeMe
    If UpdateXML Then
        StringStart = 3
        StringEnd = GetXMLLastRow - 1
    Else
        StringStart = 1
        StringEnd = GetXMLLastRow
    End If

    FileString = ""
    For i = StringStart To StringEnd
        FileString = FileString & Worksheets(".xml").Cells(i, 13) & vbCrLf
    Next i
    

    Set objStream = CreateObject("ADODB.Stream")
    objStream.Charset = "utf-8"
    objStream.Open

    If UpdateXML Then
        objStream.LoadFromFile (FilePath)
        FullText = objStream.ReadText()

        TrimmedString = FileString
        For i = 1 To Len(TrimmedString)
            If (Mid(TrimmedString, i, 1) <> " ") Then
                TrimmedString = Right(TrimmedString, Len(TrimmedString) - i + 1)
                Exit For
            End If
        Next i
        For i = Len(TrimmedString) - 2 To 1 Step -1
            TrimmedChar = Mid(TrimmedString, i, 1)
            If (TrimmedChar <> " ") And (TrimmedChar <> Chr(10)) And (TrimmedChar <> Chr(13)) Then
                TrimmedString = Left(TrimmedString, i)
                Exit For
            End If
        Next i
        PatchString = Left(TrimmedString, InStr(2, FileString, ">"))
        'Debug.Print PatchString
        XMLStart = InStr(1, FullText, PatchString)
        PatchAtTheEnd = True
        If XMLStart > 0 Then
            XMLEnd = InStr(XMLStart, FullText, "</Patch>") + 7
            If XMLEnd > 0 Then
                PatchAtTheEnd = False
            End If
        End If
        If Not PatchAtTheEnd Then
            FullText = Left(FullText, XMLStart - 1) & TrimmedString & Right(FullText, Len(FullText) - XMLEnd)
        Else
            XMLStart = InStr(1, FullText, "</Patches>")
            If XMLStart > 0 Then
                For i = XMLStart - 1 To 1 Step -1
                    If Mid(FullText, i, 1) <> " " Then
                        XMLStart = i
                        Exit For
                    End If
                Next i
                FullText = Left(FullText, XMLStart) & vbCrLf & FileString & Right(FullText, Len(FullText) - XMLStart)
                MsgBox "The patch tag containing this patch's name was not found." & vbCrLf & "Being unable to replace it, the patch was appended at the end of the file.", vbOKOnly, "Warning"
            Else
                MsgBox "</Patches> tag not found. Exiting Function.", vbOKOnly, "Error"
                GoTo SubEnd
            End If
        End If
        
        Dim objStreamWrite
        Set objStreamWrite = CreateObject("ADODB.Stream")
        objStreamWrite.Charset = "utf-8"
        objStreamWrite.Open
        objStreamWrite.WriteText FullText
        objStreamWrite.SaveToFile FilePath, 2
        objStreamWrite.Close
        objStream.Close
    Else
        objStream.WriteText FileString
        objStream.SaveToFile FilePath, 2
        objStream.Close
    End If
    Call WriteReg(RegPath, FilePath)

    FolderFromPath = Left(FilePath, InStrRev(FilePath, "\"))
    FFTorgASM = FolderFromPath & "\FFTorgASM.exe"
    
    Dim FFTorgASMExists As Integer
    Dim AfterExport As Byte
    
    
    FFTorgASMExists = Len(Dir(FFTorgASM))
    AfterExport = ReadReg(RegFolder & "After XML Export", 1, XMLExpMax)
    Select Case AfterExport
        Case 0
            GoTo SubEnd
        Case Else
            If ReadReg(RegFolder & "FFTOrgASM Focus", 0) Then
                On Error GoTo TryOpen
                AppActivate "FFTOrgASM", True
                Application.SendKeys "% ~", True
                GoTo SubEnd
            End If
    End Select
    
TryOpen:
    On Error Resume Next
    Select Case AfterExport
        Case 1
            If FFTorgASMExists Then
                If MsgBox("Open FFTorgASM?", vbYesNo, "FFTorgASM") Then
                    Shell FolderFromPath & "\FFTorgASM.exe", vbNormalFocus
                End If
            End If
        Case 2
            Shell FolderFromPath & "\FFTorgASM.exe", vbNormalFocus
    End Select
    
SubEnd:
    Unload Me
End Sub

